﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.Controls;

namespace xamCarouselListBox1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private Random random = new Random();
        Border _border;
        int _lastSelectedIndex;

        public MainWindow()
        {
            InitializeComponent();

            List<MyModel> list = new List<MyModel>();
            for (int i = 0; i < 10; i++)
            {
                MyModel model = new MyModel();
                model.Name = string.Format("Model {0}", i);
                model.TextureBrush = CreateRandomColor();
                list.Add(model);
            }
            XamCarouselListBox.ItemsSource = list;
        }

        private SolidColorBrush CreateRandomColor()
        {
            byte[] colorBytes = new byte[3];
            random.NextBytes(colorBytes);
            Color chosenColor = Color.FromRgb(colorBytes[0], colorBytes[1], colorBytes[2]);
            return new SolidColorBrush(chosenColor);
        }

        private void OnSelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            _lastSelectedIndex = XamCarouselListBox.SelectedIndex;
            MoveToSelectionOnBorder();
        }

        private void itemContentHolder_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            Point point = e.GetPosition((UIElement)sender);
            HitTestResult result = VisualTreeHelper.HitTest((UIElement)sender, point);
            if (result != null)
            {
                _border = result.VisualHit as Border;
                if (_lastSelectedIndex == XamCarouselListBox.SelectedIndex)
                {
                    MoveToSelectionOnBorder();
                }
            }
        }

        private void MoveToSelectionOnBorder()
        {
            if (_border != null)
            {
                int index = XamCarouselListBox.SelectedIndex + 1;
                int itemsPerPage = XamCarouselListBox.ViewSettings.ItemsPerPage;
                double offset = index - itemsPerPage;
                if (XamCarouselListBox.ScrollInfo != null)
                {
                    XamCarouselListBox.ScrollInfo.SetVerticalOffset(offset);
                }
            }
        }

    public class MyModel
    {
        public string Name { get; set; }
        public SolidColorBrush TextureBrush { get; set; }
    }
        }
}
